var NOT_IE = (typeof window.showModalDialog == 'undefined'); // Hack for NOT-IE detection
var IS_MOBILE = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini|Mobile|mobile|CriOS/i.test(navigator.userAgent);

var startWindow; 
if(top.opener && top.opener.window){
	if(top.opener.window.OpenModule){
		startWindow = top.opener.window;
	}else{//if it is open from a frame, send the frame startWindow instance
		if(top.opener.window.startWindow) {
			startWindow = top.opener.window.startWindow;	
		}
		else {
			startWindow = top.opener.STARTWINDOW;	
		}
	}
}

function getUrlParameterByName(name) {
	var url = window.location.href;
    name = name.replace(/[\[\]]/g, '\\$&');
	var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)');
	results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

function getCookie(name) {
  var value = '; ' + document.cookie;
  var parts = value.split('; ' + name + '=');
  if (parts.length === 2) return parts.pop().split(';').shift();
}

function setCookie(name, value, optionsParam) {
  var options = optionsParam || {};
  options.path = '/';

  if (options.expires instanceof Date) {
    options.expires = options.expires.toUTCString();
  }

  var updatedCookie = encodeURIComponent(name) + "=" + encodeURIComponent(value);

  for (var optionKey in options) {
    updatedCookie += "; " + optionKey;
    var optionValue = options[optionKey];
    if (optionValue !== true) {
      updatedCookie += "=" + optionValue;
    }
  }

  document.cookie = updatedCookie;
}

//RVAL is not used right now, we are sending it in case we will need to validate the code to modify the class with different colors
function manageRequiredAndNonRequiredChrome(REQ, NRQ, RVAL, prefix){
	if (NOT_IE) {
		// Set fields to be required
		if (REQ !== 0) {
			var LIST = REQ.split('|');
			for (var i = 0; i < LIST.length; i++) {
				RDE = LIST[i];
				TYP = RDE.slice(0, 1);
				DDE = prefix+RDE.slice(1, 99);
				if ((TYP === 'R') || (TYP === 'C')) {
					var elements = document.getElementsByName(DDE);
					if(elements){
						for (var j = 0; j < elements.length; j++) {
							var element = elements[j];
							addRequiredElementChrome(element, true)
						}
					}else{
						LGTH = document.all[DDE].length + 1;
						if (LGTH <= 0) {
							LGTH = 2 ;
						}

						for (var j = 1; j < LGTH; j++) {
							ELE = DDE + TYP + j ;
							addRequiredElementChrome(document.all[ELE], true)
						}
					}
				}
			}
		}

		// Set fields to no longer be required
		if (NRQ !== 0) {
			var LIST = NRQ.split('|');
			for (var i=0; i < LIST.length; i++) {
				RDE = LIST[i];
				TYP = RDE.slice(0, 1);
				DDE = prefix+RDE.slice(1, 99);
				if ((TYP === 'R') || (TYP === 'C')) {
					var elements = document.getElementsByName(DDE);
					if(elements){
						for (var j = 0; j < elements.length; j++) {
							var element = elements[j];
							removeRequiredElementChrome(element)
						}
					}else{
						LGTH = document.all[DDE].length + 1;
						if (LGTH <= 0) {
							LGTH = 2 ;
						}

						for (var j = 1; j < LGTH; j++) {
							ELE = DDE + TYP + j ;
							removeRequiredElementChrome(document.all[ELE])
						}
					}
				}
			}
		}
	}
}

function addRequiredElementChrome(domElement, explicitRequired) {
	var style = domElement.attributes["style"];

	if (explicitRequired || ((domElement.type == 'radio' || domElement.type == 'checkbox') && style && (style.textContent.toUpperCase().replace(/ /g,'').includes("BACKGROUND-COLOR:RGB(255,208,208)") || style.textContent.toUpperCase().replace(/ /g,'').includes("BACKGROUND-COLOR:#FFD0D0")))) {		
		var divId = "divRequired" + domElement.id + domElement.name;
		var parentElement = domElement.parentElement;
		
		if(parentElement.id == divId){
			parentElement.setAttribute("class", "requiredElementChrome");
		}else{
			var newNode = document.createElement('div');
			newNode.setAttribute("class", "requiredElementChrome");
			newNode.setAttribute("id", divId);
			parentElement.insertBefore(newNode, domElement);
			newNode.appendChild(domElement);
		}
	}
}

function removeRequiredElementChrome(domElement) {
	if(domElement.type == 'radio' || domElement.type == 'checkbox'){
		domElement.parentElement.setAttribute("class", "nonRequiredElementChrome");
	}
}

function validateGuidCookie() {
	if (NOT_IE) {
		var guid = getUrlParameterByName('guid');
		if (guid && !getCookie('guid')) {
			var d = new Date();
  			d.setTime(d.getTime() + (1*60*60*1000));
  			var expires = d.toUTCString()
			document.cookie = 'guid=' + guid + ';expires=' + expires + ';path=/';
		}
	}
}

(function() {
	// Helpers
	var canDefineGetters = !!(Object && Object.prototype && Object.prototype.__defineGetter__);
	var hasConsole = ("undefined" != typeof console);
	var handleError = function(e) {
		if (hasConsole) {
			console.log(e);
		} else {
			throw(e);
		}
	}

	validateGuidCookie();

	if ("undefined" !== typeof window.HTMLElement) {
		// Shim: <HTMLElement>.name
		// TODO: Need to detect if (HTMLElement).name will exist (it's not a part of the prototype normally)
		try {
			if (canDefineGetters) {
				HTMLElement.prototype.__defineGetter__("name",function() {
					return this.getAttribute("name");
				});
			} else {
				hasConsole && console.log('Unable to define HTMLElement.prototype.name');
			}
		} catch (e) {
			handleError(e);
		}

		// Shim: <HTMLElement>.all
		if (!HTMLElement.prototype.hasOwnProperty('all')) {
			try {
				if (canDefineGetters) {
					HTMLElement.prototype.__defineGetter__("all",function() {
						var descendants = function(element) {
							// [].slice.call() - HTMLCollection to Array
							var children = [].slice.call(element.children), found = 0;
							while (children.length > found) {
								children = children.concat([].slice.call(children[found].children));
								found++;
							}
							return children;
					   };
		 
						var all = descendants(this);
						var length = all.length; // Save length to avoid issue when adding new elements with numeric IDs
						for (var i = 0; i < length; i++) {
							if (all[i].id) {
								all[all[i].id] = all[i];
							}
							if (all[i].name) {
								if (all[all[i].name]) {
									if (all[all[i].name].constructor.name != "Array") {
										if(all[all[i].name] !== all[all[i].id]){
											all[all[i].name] = [all[all[i].name]];
										}
									}
									if(all[all[i].name] !== all[all[i].id]){
										all[all[i].name].push(all[i]);
									}
								} else {
									all[all[i].name] = all[i];
								}
							}
						}
		 
						return all;
					});
				} else {
					hasConsole && console.log('Unable to define HTMLElement.prototype.all');
				}
			} catch (e) {
				handleError(e);
			}
		}
	}

	if ('undefined' != typeof Document) {
		// Shim: <Document>.selection
		// TODO: This is an improper implementation of <Document>.selection, but it works for what we need
		if (!Document.prototype.hasOwnProperty('selection')) {
			Document.prototype.selection = {}
			Document.prototype.selection.empty = function() {}
		}
	}

	if (!String.prototype.includes) {
		String.prototype.includes = function(search, start) {
		  'use strict';
	  
		  if (search instanceof RegExp) {
			throw TypeError('first argument must not be a RegExp');
		  }
		  if (start === undefined) { start = 0; }
		  return this.indexOf(search, start) !== -1;
		};
	  }

	if (NOT_IE) { // IE gets "Permission Denied" error intermittently when opening Dev Tools (we aren't trying to patch IE's behavior anyway)
		//TODO: This instance return an array in case the element is got it from getElementById
		//this means the NodeList properties will not be there.
		document._oldgetElementsByName = document.getElementsByName;
		document._oldgetElementById = document.getElementById;
		
		document.getElementsByName = function(elemIdOrName) {
			var result = document._oldgetElementsByName(elemIdOrName);
			if (!result || result.length <= 0) {
				var elem = document._oldgetElementById(elemIdOrName); 
				if (elem) {
					result= [elem];
				}
			}

			return result;
		};

		document.getElementById = function(elemIdOrName) {
			var result = document._oldgetElementById(elemIdOrName);
			if (!result) {
				var elem = document._oldgetElementsByName(elemIdOrName); 
				if (elem && elem.length > 0) {
					result = elem[0];
				}
			}

			return result;
		};
	}

	window.EventCache = function(){
		var listEvents = [];
		return {
			listEvents : listEvents,
			add : function(){
				listEvents.push(arguments);
			},
			remove: function(){
				var i, item;

				for (var i = listEvents.length - 1; i >= 0; i--) {
					item = listEvents[i];

					if (item[0] == arguments[0] && item[1] == arguments[1] && item[2] == arguments[2]) {						

						listEvents.splice(i);
						return;
					}
				}
			},
			flush : function(){
				var i, item;
				for(i = listEvents.length - 1; i >= 0; i = i - 1){
					item = listEvents[i];
					if(item[0].removeEventListener){
						item[0].removeEventListener(item[1], item[2], item[3]);
					};
					if(item[1].substring(0, 2) != "on"){
						item[1] = "on" + item[1];
					};
					if(item[0].detachEvent){
						item[0].detachEvent(item[1], item[2]);
					};
					item[0][item[1]] = null;
					item[0]["e_"+item[1]+"_ctr"] = null;
				};
			}
		};
	}();

	window.addEvent = function( obj, type, fn ) {
		type = type.substring(0,2) == "on" ? type.substring(2) : type;
		var eventType = "on"+type;

		if (obj.addEventListener) {
			obj.addEventListener( type, fn, false );
			EventCache.add(obj, type, fn);
		} else if (obj.attachEvent) {
			obj.attachEvent( eventType, fn );
			EventCache.add(obj, type, fn);
		} else {
			var nextCtr = (obj["e_"+eventType+"_ctr"] || 0) + 1;
			if ((nextCtr == 1) && (typeof obj[eventType] == 'function')) {
				obj["e_"+eventType+"_"+nextCtr] = obj[eventType];
				nextCtr = nextCtr + 1;
				obj[eventType] = function(){
					var returnValue;
					var count = obj["e_"+eventType+"_ctr"];
					for (var i = 1; i <= count; i++) {
						returnValue = Function.prototype.apply.apply(obj["e_"+eventType+"_"+i], [window, arguments]);
					}
					return returnValue;
				};
			}
			obj["e_"+eventType+"_ctr"] = nextCtr;
			obj["e_"+eventType+"_"+nextCtr] = fn;
		}
	}

	window.removeEvent = function(obj, type, fn) {
		type = type.substring(0,2) == "on" ? type.substring(2) : type;
		var eventType = "on"+type;
		
		if(obj.removeEventListener){
			obj.removeEventListener(type, fn, false);
		};

		if(obj.detachEvent){
			obj.detachEvent(eventType, fn);
		};

		obj[eventType] = null;
		obj["e_"+eventType+"_ctr"] = null;

		EventCache.remove(obj, type, fn);
    }
	
	var openInNewWindow = function(event) {
		var href = event.currentTarget.href;
		var target = event.currentTarget.target;
		if (target == "_blank") {
			event.preventDefault();
			window.open(href, target, "resizable");
		}
	};

	window.openedWindows = [];
	addEvent(window, 'load', function(){
		if (NOT_IE) {
			var elements = document.querySelector("a");
			if(elements){
				elements.addEventListener("click", openInNewWindow);
			}

			var radiosAndChecks = document.getElementsByTagName("input");
			for (i = 0; i < radiosAndChecks.length; i++) {
				addRequiredElementChrome(radiosAndChecks[i]);
			}
		}

		// Track Windows
		var oldOpen = window.open;
		window.focusOpen = function(){
			return Function.prototype.apply.apply(oldOpen, [window, arguments]);
		};
		window.open = function(url, windowName, windowFeatures){
			if(windowFeatures){
				if(!windowFeatures.includes("resizable")){
					windowFeatures = windowFeatures+",resizable";
				}
			}else{
				windowFeatures = "resizable";
			}
			var newWindow = oldOpen(url, windowName, windowFeatures);
			if(!newWindow || newWindow.closed || typeof newWindow.closed=='undefined') { 
				setCookie('popupsAllowed', '0', {'max-age': 3600});
			} else {
				setCookie('popupsAllowed', '1', {'max-age': 3600});
			}
			window.openedWindows.push(newWindow);
			return newWindow;
		};
		// Track Alerts
		var oldAlert = window.alert;
		window.alert = function(){
			var startTime = (new Date()).getTime();
			var alertReturn = Function.prototype.apply.apply(oldAlert, [window, arguments]);
			var stopTime = (new Date()).getTime();
			if (typeof sessDebug !== 'undefined') { sessDebug.push('Alert opened for ' + (stopTime - startTime) + 'ms: ' + arguments[0]); }
			return alertReturn;
		};
	});

	addEvent(window, 'unload', function(){
		var newWindow;
		while (newWindow = window.openedWindows.shift()) {
			if (newWindow && !newWindow.closed) {
				newWindow.close();
			}
		}
	});

	addEvent(document, 'keydown', function(e){
		e = e || window.event;
		if (e) {
			var cancelEvent = false;
			switch (e.keyCode) {
				case 8: // Backspace
					if ((e.srcElement.type != 'text') && (e.srcElement.type != 'password') && (e.srcElement.type != 'textarea') && (e.srcElement.type != 'search') || (e.srcElement.readOnly)) {
						cancelEvent = true;
					}
					break;
				case 13: // Enter
					if (!window.allowEnter && e.srcElement.type != 'textarea') {
						cancelEvent = true;
					}
					break;
				case 116: // F5
				case 192: // Tilde
					cancelEvent = true;
			}
			if (cancelEvent) {
				e.cancelBubble = true;
				e.returnValue = false;
				return false;
			}
		}
	});

	var found = false;
	var cantFind = false;
	var startMenu = top;
	if (startMenu.name !== 'STARTWINDOW') {
		while ((!found) && (!cantFind)) {
			try {
				// Prevent us from getting an error if the NDoc Start Menu is
				// not in the hierarchy
				if(NOT_IE){
					startMenu = startMenu.startWindow
				}else{
					startMenu = (startMenu.top.dialogArguments || startMenu.top.opener);
				}
			} catch (e) {
				cantFind = true;
			}
			try {
				// property if the domain is different (LGXReports/Shadow)
				found = (startMenu.name === 'STARTWINDOW');
			} catch (e) {}
		}
	} else {
		found = true;
	}
	if (found && typeof(startMenu.activityHandler) != 'undefined'){
		var timeoutHandle = null;
		var activityHandler = function(){
			timeoutHandle = timeoutHandle || setTimeout(function(){
				clearTimeout(timeoutHandle);
				startMenu.activityHandler();
				timeoutHandle = null;
			},5000);
		};
		addEvent(document, 'keypress', activityHandler);
		addEvent(document, 'mousedown', activityHandler);
	}

	// Polyfill window.showModalDialog and window.showModelessDialog
	// Added a new method called closeModal to manage the function when is IE or Chrome

	window.closeModal = function(){
		if (NOT_IE){
			if(window.frameElement){
				window.frameElement.parentElement.close()
			}
		}else{
			window.close();
		}
	};

    window.showModalDialogThornBerry = function(url, arg, opt, callbackFunction) {
    	if (window.showModalDialog){
    		var result = window.showModalDialog(url, arg, opt);
    		if(callbackFunction){
					callbackFunction(result);
				}
    	} else {
			var windowForModal = window;
			
			if (window.name != "MAIN") {
				if(parent.frames["MAIN"]){
					windowForModal = parent.frames["MAIN"];
				}
			}
			
	        url = url || ''; //URL of a dialog
	        arg = arg || null; //arguments to a dialog
	        opt = opt || 'dialogWidth:660px;dialogHeight:600px'; //options: dialogTop;dialogLeft;dialogWidth;dialogHeight or CSS styles
	        var caller = showModalDialogThornBerry.caller.toString();
	        var dialog = windowForModal.document.createElement('dialog');
	        windowForModal.document.body.appendChild(dialog);
	        dialog.setAttribute('style', opt.replace(/dialog/gi, '').replace(/=/g, ':'));
	        var uniqueCloseId = "dialog-close" + Date.now();
	        var uniquebodyId = "dialog-body" + Date.now();
	        dialog.innerHTML = '<a href="#" id="' + uniqueCloseId + '" style="position: absolute; top: 0; right: 5px; font-size: 32px; color: #000; text-decoration: none; outline: none;">&times;</a><iframe id="' + uniquebodyId + '" src="' + url + '" style="border: 0; width: 100%; height: 100%;"></iframe>';
	        windowForModal.document.getElementById(uniquebodyId).contentWindow.dialogArguments = arg;
	        windowForModal.document.getElementById(uniqueCloseId).addEventListener('click', function(e) {
	            e.preventDefault();
	            dialog.close();
	        });
			dialog.addEventListener('close', function() {
				if(callbackFunction){
					var dialogFrame = windowForModal.document.getElementById(uniquebodyId);
					var returnValue = dialogFrame.contentWindow.returnValue;
					if(returnValue){
						windowForModal.document.body.removeChild(dialog);
						callbackFunction(returnValue);
					}else{
						windowForModal.document.body.removeChild(dialog);
						callbackFunction();
					}
				}
			});

	        dialog.showModal();
        }
    };
})();